package com.purui.ghip.config;

import org.springframework.beans.factory.annotation.Value;
import org.springframework.context.ApplicationListener;
import org.springframework.context.event.ContextRefreshedEvent;
import org.springframework.stereotype.Component;
import org.springframework.web.reactive.function.client.WebClient;

/**
 * App预热
 *
 * @author charlie
 * @date 2024/9/19
 */
@Component
public class AppWarmup implements ApplicationListener<ContextRefreshedEvent> {

	@Value("${server.port}")
	private int port;

	private final WebClient.Builder webClientBuilder;

	public AppWarmup(WebClient.Builder webClientBuilder) {
		this.webClientBuilder = webClientBuilder;
	}

	public void run() {
		try {
			String url = String.format("http://localhost:%s/sysInternalMutiple", port);
			webClientBuilder.build().post().uri(url).bodyValue("{}").retrieve().bodyToMono(String.class).block();
		}
		catch (Exception ex) {
			System.out.println(ex.getMessage());
		}
		System.out.println("启动成功!");
	}

	@Override
	public void onApplicationEvent(ContextRefreshedEvent event) {
		if (event.getApplicationContext() != null) {
			run();
		}
	}
}
