package com.purui.ghip.config;

import io.netty.handler.ssl.SslContext;
import io.netty.handler.ssl.SslContextBuilder;
import io.netty.handler.ssl.util.InsecureTrustManagerFactory;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.http.client.reactive.ReactorClientHttpConnector;
import org.springframework.web.reactive.function.client.WebClient;
import reactor.netty.http.client.HttpClient;

import javax.net.ssl.SSLException;

/**
 * 类说明
 *
 * @author charlie
 * @date 2024/9/12
 */
@Configuration
public class WebClientConfig {
	@Bean
	public WebClient.Builder webClientBuilder() {
		HttpClient httpClient = HttpClient
				.create()
				.secure(sslContextSpec -> {
					try {
						sslContextSpec.sslContext(getInsecureSslContext());
					}
					catch (SSLException e) {
						e.printStackTrace();
					}
				});

		return WebClient.builder()
						.clientConnector(new ReactorClientHttpConnector(httpClient));
	}

	private SslContext getInsecureSslContext() throws SSLException {
		return SslContextBuilder.forClient()
								.trustManager(InsecureTrustManagerFactory.INSTANCE)
								.build();
	}
}
